/* $Id: cl542xio.inc,v 1.4 1998/11/24 18:28:09 marcus Exp $
******************************************************************************

   Cirrus Logic I/O

   Copyright (C) 1997 Martin Erhardsen	[mee@daimi.aau.dk]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************

	This code was derived from the following source of information:
	[1]	XFree86 vga driver

******************************************************************************
*/

#include "IBM/vga_io.inc"

#define NoSEQRegs	0x20
#define	NoCRTRegs	0x1C
#define NoGRCRegs	0x0F
#define NoATCRegs	0x15

struct statetable
{
   kgiu8 MISC;
   kgiu8 HDR;
   kgiu8 SEQ[NoSEQRegs];
   kgiu8 CRT[NoCRTRegs];
   kgiu8 GRC[NoGRCRegs];
   kgiu8 ATC[NoATCRegs];
};

#if 0
static void save_state(struct statetable *state)
{
	kgiu8 i,*buf;

	state->MISC=io_in8(MISCr);	/* save miscellaneous output reg */
	io_in8(0x3C6);io_in8(0x3C6);	/* Read 4 times */
	io_in8(0x3C6);io_in8(0x3C6); 
	state->HDR=io_in8(0x3C6);	/* Read value */
	io_in8(0x3C7);			/* Reset register */

	buf=state->SEQ;
	for(i = 0; i < NoSEQRegs; i++) *(buf++)=inbSEQ(i);
	buf=state->CRT;
	for(i = 0; i < NoCRTRegs; i++) *(buf++)=inbCRT(i);
	buf=state->GRC;
	for(i = 0; i < NoGRCRegs; i++) *(buf++)=inbGRC(i);
	buf=state->ATC;
	for(i = 0; i < NoATCRegs; i++) {
		io_in8(INS1r);  /* reset AFF and setup index */
		*(buf++)=inbATC(i);
	}
	io_in8(INS1r);
	io_out8( ATCI_ENABLEDISPLAY, ATCI);
}
#endif

static void restore_state(struct statetable *state)
{
	kgiu8 i,*buf;
	outbMISC((io_in8(MISCr) & MISC_CLOCK_MASK) | state->MISC);

	io_in8(0x3C6);io_in8(0x3C6);	/* Read 4 times */
	io_in8(0x3C6);io_in8(0x3C6); 
	io_out8(state->HDR,0x3C6);	/* Write value */

	buf=state->SEQ;
	for(i=0; i < NoSEQRegs; i++) outbSEQ(*(buf++),i);
	buf=state->CRT;
#if 1
	outbCRT(inbCRT(0x11) & ~0x80, 0x11);
	outbCRT(inbCRT(0x03) | 0x80,0x03);
	state->CRT[0x03] |= 0x80;
	state->CRT[0x11]  &= ~0x80;
#endif
	for(i = 0; i < NoCRTRegs; i++) outbCRT(*(buf++), i);
	buf=state->GRC;
	for(i=0; i < NoGRCRegs; i++) outbGRC(*(buf++),i);
	buf=state->ATC;
	for(i = 0; i < NoATCRegs; i++) {
		io_in8(INS1r);
		outbATC(*(buf++),i);
  	}
	io_in8(INS1r);
	io_out8(ATCI_ENABLEDISPLAY, ATCI);

}

#if defined(DEBUG_IO)||defined(DEBUG_STATE)
static void dump_state(struct statetable *state)
{ int i;
  printk("MISC: %.2x",state->MISC);
  
  for(i = 0; i < NoSEQRegs; i++)
   { if(!(i & 0xF)) printk("\nSEQ:%.2x: ",i); printk("%.2x, ",state->SEQ[i]); }
  for(i = 0; i < NoCRTRegs; i++)
   { if(!(i & 0xf)) printk("\nCRT:%.2x: ",i); printk("%.2x, ",state->CRT[i]); }
  for(i = 0; i < NoGRCRegs; i++)
   { if(!(i & 0xF)) printk("\nGRC:%.2x: ",i); printk("%.2x, ",state->GRC[i]); }
  for(i = 0; i < NoATCRegs; i++)
   { if(!(i & 0xF)) printk("\nATC:%.2x: ",i); printk("%.2x, ",state->ATC[i]); }
  printk("\n");
}
#endif














